
Redmine - Defect #36766

Database migration from Redmine 0.8.7 or earlier fails

2022-03-15 17:31 - Bernhard Kotzur

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Database Estimated time: 0.00 hour

Target version: 4.1.7   

Resolution: Fixed Affected version: 4.1.1

Description

After import mysqldump from the old environment to get all the data and copy the files into the new environment and run

bundle exec rake db:migrate RAILS_ENV=production I got te following error:

== 20090503121505 PopulateMemberRoles: migrating ==============================

rake aborted!

StandardError: An error has occurred, all later migrations canceled:

undefined method `inherit_members?' for #<Project:0x0000000005a426a8>

/opt/rh/rh-ruby25/root/usr/share/gems/gems/activemodel-5.2.4.2/lib/active_model/attribute_methods.

rb:430:in `method_missing'

/data/redmine/sf-redmine_redmine-4.1.1/app/models/member_role.rb:72:in `block in add_role_to_subpr

ojects'

Please see details in the attached file.

Environment:

  Redmine version                4.1.1.stable

  Ruby version                   2.5.9-p229 (2021-04-05) [x86_64-linux]

  Rails version                  5.2.4.2

  Environment                    production

  Database adapter               Mysql2

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

SCM:

  Subversion                     1.7.14

  Git                            1.8.3.1

  Filesystem

Redmine plugins:

  no plugin installed

 
MySQL Server version: 5.5.52 MySQL Community Server (GPL)

-------------

Old Environment

Redmine 0.8.7.stable (MySQL)

Server version: 5.0.83-community-log MySQL Community Edition (GPL)

Related issues:

Related to Redmine - Defect #19174: db migrate error from old version to 2.6 Needs feedback

Associated revisions

Revision 21461 - 2022-03-18 03:07 - Go MAEDA

Database migration from Redmine 0.8.7 or earlier fails (#36766).

Patch by Go MAEDA.

Revision 21476 - 2022-03-20 09:23 - Go MAEDA

Merged r21461 from trunk to 4.2-stable (#36766).
Revision 21477 - 2022-03-20 09:24 - Go MAEDA

Merged r21461 from trunk to 4.1-stable (#36766).

History

#1 - 2022-03-16 09:11 - C S

Hi there,

Unfortunately, I can't help you directly, but my approach to problems like this is to try not to upgrade in such big steps. I would try upgrading to version

1.2 first... https://www.redmine.org/projects/redmine/wiki/RedmineUpgrade/46

#2 - 2022-03-16 09:43 - Go MAEDA

- Related to Defect #19174: db migrate error from old version to 2.6 added

#3 - 2022-03-16 10:08 - Go MAEDA

Could you check if changing app/models/member_role.rb as follows fixes the problem?

Index: app/models/member_role.rb

===================================================================

--- app/models/member_role.rb    (リビジョン 21454)

+++ app/models/member_role.rb    (作業コピー)

@@ -69,7 +69,7 @@

   def add_role_to_subprojects

     member.project.children.each do |subproject|

-      if subproject.inherit_members?

+      if subproject.try(:inherit_members?)

         child_member = Member.find_or_new(subproject.id, member.user_id)

         child_member.member_roles << MemberRole.new(:role => role, :inherited_from => id)

         child_member.save!

#4 - 2022-03-16 15:22 - Go MAEDA

- File 36766.patch added

The reason the error occurs is that when executing migration 20090503121505_populate_member_roles.rb, the callback for the MemberRole model

attempts to access columns in the projects table that are created in later migrations.

The problem can be fixed by replacing Member.create! with Member.insert! in the migration to avoid extra callback execution.

#5 - 2022-03-16 17:06 - Bernhard Kotzur

Hello Go MAEDA,

first thank you very much for your support!

Changing the app/models/member_role.rb as described above fixes the problem.

I was able to migrate the db without any further errors.

Now I see you provide a 36766.patch for this issue.

What is the best way for further migrations? Apply the 36766.patch or edit the app/models/member_role.rb file or both?

Thanks in advance.

#6 - 2022-03-17 00:25 - Go MAEDA

Bernhard Kotzur wrote:

Now I see you provide a 36766.patch for this issue.

What is the best way for further migrations? Apply the 36766.patch or edit the app/models/member_role.rb file or both?

 Applying the 36766.patch is better. That is the fundamental measure. Changes for app/models/member_role.rb is just a quick workaround.

#7 - 2022-03-17 00:35 - Go MAEDA

- Subject changed from db migrate error from 0.8.7 version to 4.1.1 to Database migration from Redmine 0.8.7 or earlier fails

- Target version set to 4.1.7

Setting the target version to 4.1.7.

2025-08-23 2/3

https://www.redmine.org/projects/redmine/wiki/RedmineUpgrade/46


#8 - 2022-03-18 03:07 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

#9 - 2022-03-18 18:40 - Marius BĂLTEANU

- Description updated

#10 - 2022-03-20 09:24 - Go MAEDA

- Status changed from Resolved to Closed

Committed the fix.

Files

redmine_ERROR.txt 43.1 KB 2022-03-15 Bernhard Kotzur

36766.patch 591 Bytes 2022-03-16 Go MAEDA
